import{S as ds,i as us,s as ms,e as t,k as f,w as H,t as r,M as ws,c as o,d as s,m as d,a as n,x as F,h as i,b as p,G as a,g as c,y as O,L as vs,q as D,o as S,B as M,v as gs}from"../../chunks/vendor-hf-doc-builder.js";import{I as ve}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as fs}from"../../chunks/CodeBlock-hf-doc-builder.js";function _s(Te){let m,se,w,y,N,b,ge,L,_e,ae,x,ye,te,A,oe,v,j,U,P,je,W,$e,ne,q,le,g,$,T,I,Ee,G,ke,re,E,be,J,Ae,Pe,ie,h,qe,z,Ie,Re,K,xe,Ce,Q,Be,He,V,Fe,Oe,X,De,Se,pe,_,k,Y,R,Me,Z,Ne,ce,C,B,ee,Le,Ue,he;return b=new ve({}),A=new fs({props:{code:"npm add @huggingface/hub",highlighted:'<span class="hljs-built_in">npm</span> add @huggingface/hub'}}),P=new ve({}),q=new fs({props:{code:`import { createRepo, createCommit, deleteRepo, listFiles } from "@huggingface/hub";
import type { RepoId, Credentials } from "@huggingface/hub";

const repo: RepoId = { type: "model", name: "myname/some-model" };
const credentials: Credentials = { accessToken: "hf_..." };

await createRepo({ repo, credentials, license: "mit" });

await commit({
  repo,
  credentials,
  operations: [
    {
      operation: "addOrUpdate",
      path: "file.txt",
      content: new Blob(["Hello World"]),
    },
  ],
});

await (await downloadFile({ repo, path: "README.md" })).text();

for await (const fileInfo of listFiles({repo})) {
  console.log(fileInfo);
}

await deleteRepo({ repo, credentials });`,highlighted:`<span class="hljs-keyword">import</span> { createRepo, createCommit, deleteRepo, listFiles } <span class="hljs-keyword">from</span> <span class="hljs-string">&quot;@huggingface/hub&quot;</span>;
<span class="hljs-keyword">import</span> <span class="hljs-keyword">type</span> { <span class="hljs-title class_">RepoId</span>, <span class="hljs-title class_">Credentials</span> } <span class="hljs-keyword">from</span> <span class="hljs-string">&quot;@huggingface/hub&quot;</span>;

<span class="hljs-keyword">const</span> <span class="hljs-attr">repo</span>: <span class="hljs-title class_">RepoId</span> = { <span class="hljs-attr">type</span>: <span class="hljs-string">&quot;model&quot;</span>, <span class="hljs-attr">name</span>: <span class="hljs-string">&quot;myname/some-model&quot;</span> };
<span class="hljs-keyword">const</span> <span class="hljs-attr">credentials</span>: <span class="hljs-title class_">Credentials</span> = { <span class="hljs-attr">accessToken</span>: <span class="hljs-string">&quot;hf_...&quot;</span> };

<span class="hljs-keyword">await</span> <span class="hljs-title function_">createRepo</span>({ repo, credentials, <span class="hljs-attr">license</span>: <span class="hljs-string">&quot;mit&quot;</span> });

<span class="hljs-keyword">await</span> <span class="hljs-title function_">commit</span>({
  repo,
  credentials,
  <span class="hljs-attr">operations</span>: [
    {
      <span class="hljs-attr">operation</span>: <span class="hljs-string">&quot;addOrUpdate&quot;</span>,
      <span class="hljs-attr">path</span>: <span class="hljs-string">&quot;file.txt&quot;</span>,
      <span class="hljs-attr">content</span>: <span class="hljs-keyword">new</span> <span class="hljs-title class_">Blob</span>([<span class="hljs-string">&quot;Hello World&quot;</span>]),
    },
  ],
});

<span class="hljs-keyword">await</span> (<span class="hljs-keyword">await</span> <span class="hljs-title function_">downloadFile</span>({ repo, <span class="hljs-attr">path</span>: <span class="hljs-string">&quot;README.md&quot;</span> })).<span class="hljs-title function_">text</span>();

<span class="hljs-keyword">for</span> <span class="hljs-keyword">await</span> (<span class="hljs-keyword">const</span> fileInfo <span class="hljs-keyword">of</span> <span class="hljs-title function_">listFiles</span>({repo})) {
  <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(fileInfo);
}

<span class="hljs-keyword">await</span> <span class="hljs-title function_">deleteRepo</span>({ repo, credentials });`}}),I=new ve({}),R=new ve({}),{c(){m=t("meta"),se=f(),w=t("h1"),y=t("a"),N=t("span"),H(b.$$.fragment),ge=f(),L=t("span"),_e=r("\u{1F917} Hugging Face Hub API"),ae=f(),x=t("p"),ye=r("Official utilities to use the Hugging Face hub API, still very experimental."),te=f(),H(A.$$.fragment),oe=f(),v=t("h2"),j=t("a"),U=t("span"),H(P.$$.fragment),je=f(),W=t("span"),$e=r("API"),ne=f(),H(q.$$.fragment),le=f(),g=t("h2"),$=t("a"),T=t("span"),H(I.$$.fragment),Ee=f(),G=t("span"),ke=r("Performance considerations"),re=f(),E=t("p"),be=r("When uploading large files, you may want to run the "),J=t("code"),Ae=r("commit"),Pe=r(" calls inside a worker, to offload the sha256 computations."),ie=f(),h=t("p"),qe=r("Also, use "),z=t("code"),Ie=r("Blob"),Re=r(" to avoid loading the whole files in RAM. In "),K=t("code"),xe=r("Node"),Ce=r(", it\u2019s up to you to provide a smart "),Q=t("code"),Be=r("Blob"),He=r(" wrapper around your file. Feel free to open an issue if you want "),V=t("em"),Fe=r("us"),Oe=r(" to provide the smart "),X=t("code"),De=r("Blob"),Se=r(" implementation."),pe=f(),_=t("h2"),k=t("a"),Y=t("span"),H(R.$$.fragment),Me=f(),Z=t("span"),Ne=r("Dependencies"),ce=f(),C=t("ul"),B=t("li"),ee=t("code"),Le=r("hash-wasm"),Ue=r(" : Only used in the browser, when committing files over 10 MB. Browsers do not natively support streaming sha256 computations."),this.h()},l(e){const l=ws('[data-svelte="svelte-1phssyn"]',document.head);m=o(l,"META",{name:!0,content:!0}),l.forEach(s),se=d(e),w=o(e,"H1",{class:!0});var fe=n(w);y=o(fe,"A",{id:!0,class:!0,href:!0});var Ge=n(y);N=o(Ge,"SPAN",{});var Je=n(N);F(b.$$.fragment,Je),Je.forEach(s),Ge.forEach(s),ge=d(fe),L=o(fe,"SPAN",{});var ze=n(L);_e=i(ze,"\u{1F917} Hugging Face Hub API"),ze.forEach(s),fe.forEach(s),ae=d(e),x=o(e,"P",{});var Ke=n(x);ye=i(Ke,"Official utilities to use the Hugging Face hub API, still very experimental."),Ke.forEach(s),te=d(e),F(A.$$.fragment,e),oe=d(e),v=o(e,"H2",{class:!0});var de=n(v);j=o(de,"A",{id:!0,class:!0,href:!0});var Qe=n(j);U=o(Qe,"SPAN",{});var Ve=n(U);F(P.$$.fragment,Ve),Ve.forEach(s),Qe.forEach(s),je=d(de),W=o(de,"SPAN",{});var Xe=n(W);$e=i(Xe,"API"),Xe.forEach(s),de.forEach(s),ne=d(e),F(q.$$.fragment,e),le=d(e),g=o(e,"H2",{class:!0});var ue=n(g);$=o(ue,"A",{id:!0,class:!0,href:!0});var Ye=n($);T=o(Ye,"SPAN",{});var Ze=n(T);F(I.$$.fragment,Ze),Ze.forEach(s),Ye.forEach(s),Ee=d(ue),G=o(ue,"SPAN",{});var es=n(G);ke=i(es,"Performance considerations"),es.forEach(s),ue.forEach(s),re=d(e),E=o(e,"P",{});var me=n(E);be=i(me,"When uploading large files, you may want to run the "),J=o(me,"CODE",{});var ss=n(J);Ae=i(ss,"commit"),ss.forEach(s),Pe=i(me," calls inside a worker, to offload the sha256 computations."),me.forEach(s),ie=d(e),h=o(e,"P",{});var u=n(h);qe=i(u,"Also, use "),z=o(u,"CODE",{});var as=n(z);Ie=i(as,"Blob"),as.forEach(s),Re=i(u," to avoid loading the whole files in RAM. In "),K=o(u,"CODE",{});var ts=n(K);xe=i(ts,"Node"),ts.forEach(s),Ce=i(u,", it\u2019s up to you to provide a smart "),Q=o(u,"CODE",{});var os=n(Q);Be=i(os,"Blob"),os.forEach(s),He=i(u," wrapper around your file. Feel free to open an issue if you want "),V=o(u,"EM",{});var ns=n(V);Fe=i(ns,"us"),ns.forEach(s),Oe=i(u," to provide the smart "),X=o(u,"CODE",{});var ls=n(X);De=i(ls,"Blob"),ls.forEach(s),Se=i(u," implementation."),u.forEach(s),pe=d(e),_=o(e,"H2",{class:!0});var we=n(_);k=o(we,"A",{id:!0,class:!0,href:!0});var rs=n(k);Y=o(rs,"SPAN",{});var is=n(Y);F(R.$$.fragment,is),is.forEach(s),rs.forEach(s),Me=d(we),Z=o(we,"SPAN",{});var ps=n(Z);Ne=i(ps,"Dependencies"),ps.forEach(s),we.forEach(s),ce=d(e),C=o(e,"UL",{});var cs=n(C);B=o(cs,"LI",{});var We=n(B);ee=o(We,"CODE",{});var hs=n(ee);Le=i(hs,"hash-wasm"),hs.forEach(s),Ue=i(We," : Only used in the browser, when committing files over 10 MB. Browsers do not natively support streaming sha256 computations."),We.forEach(s),cs.forEach(s),this.h()},h(){p(m,"name","hf:doc:metadata"),p(m,"content",JSON.stringify(ys)),p(y,"id","hugging-face-hub-api"),p(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(y,"href","#hugging-face-hub-api"),p(w,"class","relative group"),p(j,"id","api"),p(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(j,"href","#api"),p(v,"class","relative group"),p($,"id","performance-considerations"),p($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p($,"href","#performance-considerations"),p(g,"class","relative group"),p(k,"id","dependencies"),p(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(k,"href","#dependencies"),p(_,"class","relative group")},m(e,l){a(document.head,m),c(e,se,l),c(e,w,l),a(w,y),a(y,N),O(b,N,null),a(w,ge),a(w,L),a(L,_e),c(e,ae,l),c(e,x,l),a(x,ye),c(e,te,l),O(A,e,l),c(e,oe,l),c(e,v,l),a(v,j),a(j,U),O(P,U,null),a(v,je),a(v,W),a(W,$e),c(e,ne,l),O(q,e,l),c(e,le,l),c(e,g,l),a(g,$),a($,T),O(I,T,null),a(g,Ee),a(g,G),a(G,ke),c(e,re,l),c(e,E,l),a(E,be),a(E,J),a(J,Ae),a(E,Pe),c(e,ie,l),c(e,h,l),a(h,qe),a(h,z),a(z,Ie),a(h,Re),a(h,K),a(K,xe),a(h,Ce),a(h,Q),a(Q,Be),a(h,He),a(h,V),a(V,Fe),a(h,Oe),a(h,X),a(X,De),a(h,Se),c(e,pe,l),c(e,_,l),a(_,k),a(k,Y),O(R,Y,null),a(_,Me),a(_,Z),a(Z,Ne),c(e,ce,l),c(e,C,l),a(C,B),a(B,ee),a(ee,Le),a(B,Ue),he=!0},p:vs,i(e){he||(D(b.$$.fragment,e),D(A.$$.fragment,e),D(P.$$.fragment,e),D(q.$$.fragment,e),D(I.$$.fragment,e),D(R.$$.fragment,e),he=!0)},o(e){S(b.$$.fragment,e),S(A.$$.fragment,e),S(P.$$.fragment,e),S(q.$$.fragment,e),S(I.$$.fragment,e),S(R.$$.fragment,e),he=!1},d(e){s(m),e&&s(se),e&&s(w),M(b),e&&s(ae),e&&s(x),e&&s(te),M(A,e),e&&s(oe),e&&s(v),M(P),e&&s(ne),M(q,e),e&&s(le),e&&s(g),M(I),e&&s(re),e&&s(E),e&&s(ie),e&&s(h),e&&s(pe),e&&s(_),M(R),e&&s(ce),e&&s(C)}}}const ys={local:"hugging-face-hub-api",sections:[{local:"api",title:"API"},{local:"performance-considerations",title:"Performance considerations"},{local:"dependencies",title:"Dependencies"}],title:"\u{1F917} Hugging Face Hub API"};function js(Te){return gs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class bs extends ds{constructor(m){super();us(this,m,js,_s,ms,{})}}export{bs as default,ys as metadata};
